#!/usr/bin/perl 

use strict;
use warnings;

my $Hp = 20.0;
my $Hm = 14.5;
my $Sp = 0.015;
my $Sm = 0.002;

my $R = 1.985878e-3;		# Gas constant (kcal / mol / K)
my $fac = 2.0836644e10;	# Boltzman's constant / Planck's constant

my $dw = 2000.0;
my $T = 290.0;
my $Gp = $Hp - $Sp*$T;
my $Gm = $Hm - $Sm*$T;
my $G = $Gp - $Gm;
my $RT = $R * $T;
my $kex = $fac * $T * (exp(-$Gp/$RT) + exp(-$Gm/$RT));
my $papb = exp(-$G/$RT) / ((1.0 + exp(-$G/$RT))**2);
print "T\tkex\tpapb\n";
printf "%5.1f\t%5.2f\t%5.5f\n",$T,$kex,$papb;
