// Method class
// Kenji Sugase		8/31/2012

#ifndef __METHOD_H__
#define __METHOD_H__

#include "Type.h"

namespace {
	const int METHOD_UNDEF  = 0;
	const int METHOD_INIT   = 1;
	const int METHOD_ONE    = 2;
	const int METHOD_ONEEX  = 3;
	const int METHOD_GRID   = 4;
	const int METHOD_RANDOM = 5;
	const int METHOD_MCMIN  = 6;
	const int METHOD_RMCMIN = 7;
}

struct OneMethod {
	int type;		// method type: INITIAL, GRID, MARQUARDT, RANDOM, MCMIN
	int iter;		// iterations of RANDOM and MCMIN calculations
	int iterMC;		// iterations of MCMIN calculation in RMCMIN 
	double scale;		// scale in MCMIN calculation

	OneMethod() : type(0), iter(10), iterMC(10), scale(0.01) {}
};

class Method {
private:
	vector<OneMethod> ctrl;

	bool isMatch(const string &word, const char *method);
	int str2long(const string &word);
	double str2double(const string &word);

public:
	Method();
	~Method();

	void Clear();
	void Add(const svect &words);
	string report(size_t nm) const;
	size_t size() const;
	int Type(size_t nm) const;
	int Iter(size_t nm) const;
	int IterMC(size_t nm) const;
	double Scale(size_t nm) const;
	void check_option(int size, int limit, const char *name) const;

};

#endif
