// Rules class
//	Object to handle the rules for marking up parameter names
// Jonathan C. Lansing	3/6/05
// Kenji Sugase		10/8/09

#ifndef __RULES_h__
#define __RULES_h__

#include "Type.h"

class Rules {
private:
	svect parm_name;		// base parameter name
	dvect parm_min;			// parameter lower limit
	dvect parm_max;			// parameter upper limit
	svect parm_index;		// parameter name markup instructions

	void append_int(string &str, int i);
	int index(const string &str);

public:
	Rules();
	~Rules();

	void Define_Parm(const char *name, double min, double max, const char *index);
	void markup(string &str, int i, const ivect &idx);
	int decompose(const string &PAR, ivect &v);
	int basePAR_size() const;
	double Get_LowerBound(size_t num) const;
	double Get_UpperBound(size_t num) const;
};

#endif
