// ParSet class
// Kenji Sugase		2012/7/11

#include "ParSet.h"
#include <iostream>

ParSet::ParSet() {}

void ParSet::resize(size_t szSet, size_t szPar)
{
	lchi.resize(szSet);
	p.resize(szPar);
}

void ParSet::zero()
{
	chi = 0.0;
	fill(lchi.begin(), lchi.end(), 0.0);
	fill(p.begin(), p.end(), 0.0);
}

// copy partial parameter set
void ParSet::copy(const ParSet &p2, const ivect &plist, size_t ns)
{
	lchi[ns] = p2.lchi[ns];
	recalc_chi();
	int sz = plist.size();
	for (int i = 0; i < sz; i++) {
		int np = plist[i];
		p[np] = p2.p[np];
	}
}

void ParSet::recalc_chi()
{
	chi = 0;
	int sz = lchi.size();
	for (int ns = 0; ns < sz; ns++) {
		chi += lchi[ns];
	}
}
