// func_exp.cpp
// Kenji Sugase		2/21/2012

#include <iostream>
#include <cmath>
#include <cstdlib>
#include "Data.h"
#include "FuncLib.h"
#include "Type.h"
#include "Mathlib.h"

using namespace std;


// EXP4: f(x) = Aexp(Bx) + C
// par[0]	A	(unitless)
// par[1]	B	(unitless)
// par[2]	C	(unitless)
double f2exp3(const Data &data, double *par, dvect &dy, const bvect &fixed)
{
	int i_a = data.map[0];
	int i_b = data.map[1];
	int i_c = data.map[2];
	int i_d = data.map[3];
	int i_e = data.map[4];
	int i_f = data.map[5];
	
	double x, A, Bx, expBx, C;
	double D, Ex, expEx, F;
	x  = data.x[0];
	A  = par[0];
	Bx = x * par[1];
	C  = par[2];
	D  = par[3];
	Ex = x * par[4];
	F  = par[5];
	if (Bx < EXP_MIN) { return -HUGE_VAL; }
	if (Ex < EXP_MIN) { return -HUGE_VAL; }
	if (Bx > EXP_MAX) { return  HUGE_VAL; }
	if (Ex > EXP_MAX) { return  HUGE_VAL; }
	expBx = exp(Bx);
	expEx = exp(Ex);
	if (dy.size()) {
		dy[i_a] = exp(Bx);
		dy[i_b] = A * x * exp(Bx);
		dy[i_c] = 1;
		dy[i_d] = exp(Ex);
		dy[i_e] = D * x * exp(Ex);
		dy[i_f] = 1;
	}
	return A * expBx + C + D * expEx + F;
}



int Funclib::Read_Bio_Funcs(int idx)
{
	// Exponential function with a constant offset (3 parameters)
	idx = Define_Func(&f2exp3, "2Exp3", "f(x) = Aexp(Bx) + C + Dexp(Ex) + F", "EXP");
	Define_Parm(idx, "a"    ,-1.0e9, 1.0e9);
	Define_Parm(idx, "b"    ,-1.0e6, 1.0e6);
	Define_Parm(idx, "c"    ,-1.0e9, 1.0e9);
	Define_Parm(idx, "d"    ,-1.0e9, 1.0e9);
	Define_Parm(idx, "e"    ,-1.0e6, 1.0e6);
	Define_Parm(idx, "f"    ,-1.0e9, 1.0e9);















	return idx;
}



