// Data.h	Data class functions
// Jonathan C. Lansing
// Kenji Sugase		2/1/10

#ifndef __DATA_H__
#define __DATA_H__

#include "Type.h"

struct Data
{
	int   ds;		// data set number
	dvect  x;		// independent variables
	ivect  idx;		// index values
	double y;		// dependent variable
	double dy;		// uncertainty in y
	ivect  map;		// maps model parameter to parameter list entry
	double idy;		// 1/dy

	Data() {}

	Data(int ns, dvect &nx, ivect &ix, double ny, double ndy, ivect &lstPAR)
		: ds(ns), x(nx), idx(ix), y(ny), dy(ndy), map(lstPAR) { idy = 1.0/ndy; }
};

#endif
